- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

SRP_user_pwd_new, SRP_user_pwd_free, SRP_user_pwd_set1_ids, SRP_user_pwd_set_gN, SRP_user_pwd_set0_sv - Functions to create a record of SRP user verifier information

# SYNOPSIS

     #include <openssl/srp.h>

     SRP_user_pwd *SRP_user_pwd_new(void);
     void SRP_user_pwd_free(SRP_user_pwd *user_pwd);

     int SRP_user_pwd_set1_ids(SRP_user_pwd *user_pwd, const char *id, const char *info);
     void SRP_user_pwd_set_gN(SRP_user_pwd *user_pwd, const BIGNUM *g, const BIGNUM *N);
     int SRP_user_pwd_set0_sv(SRP_user_pwd *user_pwd, BIGNUM *s, BIGNUM *v);

# DESCRIPTION

The `SRP_user_pwd_new()` function allocates a structure to store a user verifier record.

The `SRP_user_pwd_free()` function frees up the user_pwd structure. If user_pwd is NULL, nothing is done.

The SRP_user_pwd_set1_ids() function sets the username to id and the optional user info to info for user_pwd. The library allocates new copies of id and info, the caller still owns the original memory.

The SRP_user_pwd_set0_sv() function sets the user salt to s and the verifier to v for user_pwd. The library takes ownership of the values, they should not be freed by the caller.

The `SRP_user_pwd_set_gN()` function sets the SRP group parameters for user_pwd. The memory is not freed by `SRP_user_pwd_free()`, the caller must make sure it is freed once it is no longer used.

# RETURN VALUES

SRP_user_pwd_set1_ids() returns 1 on success and 0 on failure or if id was NULL.

SRP_user_pwd_set0_sv() returns 1 if both s and v are not NULL, 0 otherwise.

# SEE ALSO

openssl-srp(1), SRP_create_verifier(3), SRP_VBASE_new(3), SSL_CTX_set_srp_password(3)

# HISTORY

These functions were made public in OpenSSL 3.0.

# COPYRIGHT

Copyright 2018 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.